package anywheresoftware.b4a.table;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "anywheresoftware.b4a.table", "anywheresoftware.b4a.table.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "anywheresoftware.b4a.table", "anywheresoftware.b4a.table.main");
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public static class _rowcol{
public boolean IsInitialized;
public int Row;
public int Col;
public void Initialize() {
IsInitialized = true;
Row = 0;
Col = 0;
}
@Override
		public String toString() {
			return BA.TypeToString(this, false);
		}}
public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.sql.SQL _sql1 = null;
public static String _dbfilename = "";
public static String _dbfiledir = "";
public anywheresoftware.b4a.objects.ScrollViewWrapper _scvlist = null;
public anywheresoftware.b4a.objects.PanelWrapper _table = null;
public anywheresoftware.b4a.objects.collections.Map _selecteditems = null;
public static int _numberofcolumns = 0;
public static int _rowheight = 0;
public static int _rowheight_1 = 0;
public static int _linecolor = 0;
public static int[] _columnwidth = null;
public static int[] _columnwidth_1 = null;
public static int _collinewidth = 0;
public static int _rowlinewidth = 0;
public static int _selectedrow = 0;
public static int _selectedrowcolor = 0;
public anywheresoftware.b4a.objects.PanelWrapper _pnlbtnwerknemers = null;
public static int[] _cellcolor = null;
public static int[] _fontcolor = null;
public static float[] _fontsize = null;
public static int[] _alignment = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
		Debug.PushSubsStack("Activity_Create (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
int _i = 0;
Debug.locals.put("FirstTime", _firsttime);
 BA.debugLineNum = 69;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
Debug.ShouldStop(16);
 BA.debugLineNum = 70;BA.debugLine="Dim i As Int";
Debug.ShouldStop(32);
_i = 0;Debug.locals.put("i", _i);
 BA.debugLineNum = 71;BA.debugLine="Activity.LoadLayout(\"layout.bal\")";
Debug.ShouldStop(64);
mostCurrent._activity.LoadLayout("layout.bal",mostCurrent.activityBA);
 BA.debugLineNum = 73;BA.debugLine="If File.Exists(DBFileDir, DBFileName) = False  Then";
Debug.ShouldStop(256);
if (anywheresoftware.b4a.keywords.Common.File.Exists(_dbfiledir,_dbfilename)==anywheresoftware.b4a.keywords.Common.False) { 
 BA.debugLineNum = 74;BA.debugLine="If FirstTime Then";
Debug.ShouldStop(512);
if (_firsttime) { 
 BA.debugLineNum = 75;BA.debugLine="File.Copy(File.DirAssets, DBFileName, DBFileDir, DBFileName)";
Debug.ShouldStop(1024);
anywheresoftware.b4a.keywords.Common.File.Copy(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),_dbfilename,_dbfiledir,_dbfilename);
 BA.debugLineNum = 76;BA.debugLine="SQL1.Initialize(DBFileDir, DBFileName, True)";
Debug.ShouldStop(2048);
_sql1.Initialize(_dbfiledir,_dbfilename,anywheresoftware.b4a.keywords.Common.True);
 };
 }else {
 BA.debugLineNum = 79;BA.debugLine="If FirstTime Then";
Debug.ShouldStop(16384);
if (_firsttime) { 
 BA.debugLineNum = 80;BA.debugLine="SQL1.Initialize(DBFileDir, DBFileName, True)";
Debug.ShouldStop(32768);
_sql1.Initialize(_dbfiledir,_dbfilename,anywheresoftware.b4a.keywords.Common.True);
 };
 };
 BA.debugLineNum = 84;BA.debugLine="scvList.Initialize(0)";
Debug.ShouldStop(524288);
mostCurrent._scvlist.Initialize(mostCurrent.activityBA,(int)(0));
 BA.debugLineNum = 86;BA.debugLine="scvList.Panel.Color=Colors.Black";
Debug.ShouldStop(2097152);
mostCurrent._scvlist.getPanel().setColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 BA.debugLineNum = 87;BA.debugLine="Table = scvList.Panel";
Debug.ShouldStop(4194304);
mostCurrent._table = mostCurrent._scvlist.getPanel();
 BA.debugLineNum = 88;BA.debugLine="Table.Color = LineColor";
Debug.ShouldStop(8388608);
mostCurrent._table.setColor(_linecolor);
 BA.debugLineNum = 89;BA.debugLine="Activity.AddView(scvList, 5%x, 10%y, 90%x, 80%y)";
Debug.ShouldStop(16777216);
mostCurrent._activity.AddView((android.view.View)(mostCurrent._scvlist.getObject()),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(5),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(10),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(90),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(80),mostCurrent.activityBA));
 BA.debugLineNum = 90;BA.debugLine="ColumnWidth(0) = ColLineWidth				' hides the first column";
Debug.ShouldStop(33554432);
_columnwidth[(int)(0)] = _collinewidth;
 BA.debugLineNum = 92;BA.debugLine="For i=0 To NumberOfColumns-1";
Debug.ShouldStop(134217728);
{
final double step55 = 1;
final double limit55 = (int)(_numberofcolumns-1);
for (_i = (int)(0); (step55 > 0 && _i <= limit55) || (step55 < 0 && _i >= limit55); _i += step55) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 94;BA.debugLine="ColumnWidth_1(i) = ColumnWidth(i)-ColLineWidth";
Debug.ShouldStop(536870912);
_columnwidth_1[_i] = (int)(_columnwidth[_i]-_collinewidth);
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 96;BA.debugLine="SelectedRow = -1";
Debug.ShouldStop(-2147483648);
_selectedrow = (int)(-1);
 BA.debugLineNum = 97;BA.debugLine="SelectedItems.Initialize";
Debug.ShouldStop(1);
mostCurrent._selecteditems.Initialize();
 BA.debugLineNum = 99;BA.debugLine="ReadSQLTable";
Debug.ShouldStop(4);
_readsqltable();
 BA.debugLineNum = 102;BA.debugLine="End Sub";
Debug.ShouldStop(32);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_pause(boolean _userclosed) throws Exception{
		Debug.PushSubsStack("Activity_Pause (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("UserClosed", _userclosed);
 BA.debugLineNum = 245;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
Debug.ShouldStop(1048576);
 BA.debugLineNum = 247;BA.debugLine="End Sub";
Debug.ShouldStop(4194304);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_resume() throws Exception{
		Debug.PushSubsStack("Activity_Resume (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 241;BA.debugLine="Sub Activity_Resume";
Debug.ShouldStop(65536);
 BA.debugLineNum = 243;BA.debugLine="End Sub";
Debug.ShouldStop(262144);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _addrow(String[] _values) throws Exception{
		Debug.PushSubsStack("AddRow (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
int _colwidth = 0;
int _lastrow = 0;
int _i = 0;
anywheresoftware.b4a.objects.LabelWrapper _l = null;
anywheresoftware.b4a.table.main._rowcol _rc = null;
Debug.locals.put("Values", _values);
 BA.debugLineNum = 196;BA.debugLine="Sub AddRow(Values() As String)";
Debug.ShouldStop(8);
 BA.debugLineNum = 198;BA.debugLine="Dim ColWidth As Int";
Debug.ShouldStop(32);
_colwidth = 0;Debug.locals.put("ColWidth", _colwidth);
 BA.debugLineNum = 200;BA.debugLine="If Values.Length <> NumberOfColumns Then";
Debug.ShouldStop(128);
if (_values.length!=_numberofcolumns) { 
 BA.debugLineNum = 201;BA.debugLine="Log(\"Wrong number of values.\")";
Debug.ShouldStop(256);
anywheresoftware.b4a.keywords.Common.Log("Wrong number of values.");
 BA.debugLineNum = 202;BA.debugLine="Return";
Debug.ShouldStop(512);
if (true) return "";
 };
 BA.debugLineNum = 204;BA.debugLine="Dim lastRow As Int";
Debug.ShouldStop(2048);
_lastrow = 0;Debug.locals.put("lastRow", _lastrow);
 BA.debugLineNum = 205;BA.debugLine="lastRow = NumberOfRows";
Debug.ShouldStop(4096);
_lastrow = _numberofrows();Debug.locals.put("lastRow", _lastrow);
 BA.debugLineNum = 206;BA.debugLine="ColWidth=0";
Debug.ShouldStop(8192);
_colwidth = (int)(0);Debug.locals.put("ColWidth", _colwidth);
 BA.debugLineNum = 207;BA.debugLine="For i = 0 To NumberOfColumns - 1";
Debug.ShouldStop(16384);
{
final double step131 = 1;
final double limit131 = (int)(_numberofcolumns-1);
for (_i = (int)(0); (step131 > 0 && _i <= limit131) || (step131 < 0 && _i >= limit131); _i += step131) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 208;BA.debugLine="Dim l As Label";
Debug.ShouldStop(32768);
_l = new anywheresoftware.b4a.objects.LabelWrapper();Debug.locals.put("l", _l);
 BA.debugLineNum = 209;BA.debugLine="l.Initialize(\"cell\")";
Debug.ShouldStop(65536);
_l.Initialize(mostCurrent.activityBA,"cell");
 BA.debugLineNum = 210;BA.debugLine="l.Text = Values(i)";
Debug.ShouldStop(131072);
_l.setText((Object)(_values[_i]));
 BA.debugLineNum = 211;BA.debugLine="l.Gravity = Alignment(i)";
Debug.ShouldStop(262144);
_l.setGravity(_alignment[_i]);
 BA.debugLineNum = 212;BA.debugLine="l.TextSize = FontSize(i)";
Debug.ShouldStop(524288);
_l.setTextSize(_fontsize[_i]);
 BA.debugLineNum = 213;BA.debugLine="l.TextColor = FontColor(i)";
Debug.ShouldStop(1048576);
_l.setTextColor(_fontcolor[_i]);
 BA.debugLineNum = 214;BA.debugLine="l.Color=CellColor(i)";
Debug.ShouldStop(2097152);
_l.setColor(_cellcolor[_i]);
 BA.debugLineNum = 215;BA.debugLine="Dim rc As RowCol";
Debug.ShouldStop(4194304);
_rc = new anywheresoftware.b4a.table.main._rowcol();Debug.locals.put("rc", _rc);
 BA.debugLineNum = 216;BA.debugLine="rc.Initialize";
Debug.ShouldStop(8388608);
_rc.Initialize();
 BA.debugLineNum = 217;BA.debugLine="rc.Col = i";
Debug.ShouldStop(16777216);
_rc.Col = _i;Debug.locals.put("rc", _rc);
 BA.debugLineNum = 218;BA.debugLine="rc.Row = lastRow";
Debug.ShouldStop(33554432);
_rc.Row = _lastrow;Debug.locals.put("rc", _rc);
 BA.debugLineNum = 219;BA.debugLine="l.Tag = rc";
Debug.ShouldStop(67108864);
_l.setTag((Object)(_rc));
 BA.debugLineNum = 221;BA.debugLine="Table.AddView(l, ColWidth, RowHeight * lastRow, ColumnWidth_1(i), RowHeight_1)";
Debug.ShouldStop(268435456);
mostCurrent._table.AddView((android.view.View)(_l.getObject()),_colwidth,(int)(_rowheight*_lastrow),_columnwidth_1[_i],_rowheight_1);
 BA.debugLineNum = 222;BA.debugLine="ColWidth=ColWidth+ColumnWidth(i)";
Debug.ShouldStop(536870912);
_colwidth = (int)(_colwidth+_columnwidth[_i]);Debug.locals.put("ColWidth", _colwidth);
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 224;BA.debugLine="Table.Height = NumberOfRows * RowHeight";
Debug.ShouldStop(-2147483648);
mostCurrent._table.setHeight((int)(_numberofrows()*_rowheight));
 BA.debugLineNum = 225;BA.debugLine="End Sub";
Debug.ShouldStop(1);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btngadoor_click() throws Exception{
		Debug.PushSubsStack("btnGaDoor_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 123;BA.debugLine="Sub btnGaDoor_Click";
Debug.ShouldStop(67108864);
 BA.debugLineNum = 124;BA.debugLine="Msgbox(SelectedItems,\"test\")";
Debug.ShouldStop(134217728);
anywheresoftware.b4a.keywords.Common.Msgbox(String.valueOf(mostCurrent._selecteditems),"test",mostCurrent.activityBA);
 BA.debugLineNum = 130;BA.debugLine="If SelectedItems Then";
Debug.ShouldStop(2);
if (BA.ObjectToBoolean(mostCurrent._selecteditems)) { 
 BA.debugLineNum = 132;BA.debugLine="Table.Visible = False";
Debug.ShouldStop(8);
mostCurrent._table.setVisible(anywheresoftware.b4a.keywords.Common.False);
 BA.debugLineNum = 133;BA.debugLine="pnlBtnWerknemers.Visible = False";
Debug.ShouldStop(16);
mostCurrent._pnlbtnwerknemers.setVisible(anywheresoftware.b4a.keywords.Common.False);
 }else {
 BA.debugLineNum = 135;BA.debugLine="Msgbox(\"Je moet je eigen en je collega's van vandaag selecteren voor je doorgaat\",\"Error\")";
Debug.ShouldStop(64);
anywheresoftware.b4a.keywords.Common.Msgbox("Je moet je eigen en je collega's van vandaag selecteren voor je doorgaat","Error",mostCurrent.activityBA);
 };
 BA.debugLineNum = 137;BA.debugLine="End Sub";
Debug.ShouldStop(256);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _cell_click() throws Exception{
		Debug.PushSubsStack("Cell_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
anywheresoftware.b4a.table.main._rowcol _rc = null;
anywheresoftware.b4a.objects.LabelWrapper _l = null;
String _txt = "";
int _i = 0;
 BA.debugLineNum = 139;BA.debugLine="Sub Cell_Click";
Debug.ShouldStop(1024);
 BA.debugLineNum = 140;BA.debugLine="Dim rc As RowCol";
Debug.ShouldStop(2048);
_rc = new anywheresoftware.b4a.table.main._rowcol();Debug.locals.put("rc", _rc);
 BA.debugLineNum = 141;BA.debugLine="Dim l As Label";
Debug.ShouldStop(4096);
_l = new anywheresoftware.b4a.objects.LabelWrapper();Debug.locals.put("l", _l);
 BA.debugLineNum = 142;BA.debugLine="Dim txt As String";
Debug.ShouldStop(8192);
_txt = "";Debug.locals.put("txt", _txt);
 BA.debugLineNum = 144;BA.debugLine="l = Sender";
Debug.ShouldStop(32768);
_l.setObject((android.widget.TextView)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 BA.debugLineNum = 145;BA.debugLine="rc = l.Tag";
Debug.ShouldStop(65536);
_rc = (anywheresoftware.b4a.table.main._rowcol)(_l.getTag());Debug.locals.put("rc", _rc);
 BA.debugLineNum = 146;BA.debugLine="SelectRow(rc.Row)";
Debug.ShouldStop(131072);
_selectrow(_rc.Row);
 BA.debugLineNum = 147;BA.debugLine="Activity.Title = \"Cell clicked: (\" & rc.Row & \", \" & rc.Col & \")\"";
Debug.ShouldStop(262144);
mostCurrent._activity.setTitle((Object)("Cell clicked: ("+BA.NumberToString(_rc.Row)+", "+BA.NumberToString(_rc.Col)+")"));
 BA.debugLineNum = 148;BA.debugLine="Activity.Title = \"Code = \"&GetView(rc.row,0).Text";
Debug.ShouldStop(524288);
mostCurrent._activity.setTitle((Object)("Code = "+_getview(_rc.Row,(int)(0)).getText()));
 BA.debugLineNum = 149;BA.debugLine="txt=\"Codes = \"";
Debug.ShouldStop(1048576);
_txt = "Codes = ";Debug.locals.put("txt", _txt);
 BA.debugLineNum = 150;BA.debugLine="For i=0 To SelectedItems.Size-1";
Debug.ShouldStop(2097152);
{
final double step95 = 1;
final double limit95 = (int)(mostCurrent._selecteditems.getSize()-1);
for (_i = (int)(0); (step95 > 0 && _i <= limit95) || (step95 < 0 && _i >= limit95); _i += step95) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 151;BA.debugLine="If i=0 Then";
Debug.ShouldStop(4194304);
if (_i==0) { 
 BA.debugLineNum = 152;BA.debugLine="txt=txt&SelectedItems.GetValueAt(i)";
Debug.ShouldStop(8388608);
_txt = _txt+String.valueOf(mostCurrent._selecteditems.GetValueAt(_i));Debug.locals.put("txt", _txt);
 }else {
 BA.debugLineNum = 154;BA.debugLine="txt=txt&\" / \"&SelectedItems.GetValueAt(i)";
Debug.ShouldStop(33554432);
_txt = _txt+" / "+String.valueOf(mostCurrent._selecteditems.GetValueAt(_i));Debug.locals.put("txt", _txt);
 };
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 158;BA.debugLine="Activity.Title = txt";
Debug.ShouldStop(536870912);
mostCurrent._activity.setTitle((Object)(_txt));
 BA.debugLineNum = 159;BA.debugLine="End Sub";
Debug.ShouldStop(1073741824);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _getcell(int _row,int _col) throws Exception{
		Debug.PushSubsStack("GetCell (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Row", _row);
Debug.locals.put("Col", _col);
 BA.debugLineNum = 236;BA.debugLine="Sub GetCell(Row As Int, Col As Int) As String";
Debug.ShouldStop(2048);
 BA.debugLineNum = 238;BA.debugLine="Return GetView(Row, Col).Text";
Debug.ShouldStop(8192);
if (true) return _getview(_row,_col).getText();
 BA.debugLineNum = 239;BA.debugLine="End Sub";
Debug.ShouldStop(16384);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static anywheresoftware.b4a.objects.LabelWrapper  _getview(int _row,int _col) throws Exception{
		Debug.PushSubsStack("GetView (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
anywheresoftware.b4a.objects.LabelWrapper _l = null;
Debug.locals.put("Row", _row);
Debug.locals.put("Col", _col);
 BA.debugLineNum = 189;BA.debugLine="Sub GetView(Row As Int, Col As Int) As Label";
Debug.ShouldStop(268435456);
 BA.debugLineNum = 191;BA.debugLine="Dim l As Label";
Debug.ShouldStop(1073741824);
_l = new anywheresoftware.b4a.objects.LabelWrapper();Debug.locals.put("l", _l);
 BA.debugLineNum = 192;BA.debugLine="l = Table.GetView(Row * NumberOfColumns + Col)";
Debug.ShouldStop(-2147483648);
_l.setObject((android.widget.TextView)(mostCurrent._table.GetView((int)(_row*_numberofcolumns+_col)).getObject()));
 BA.debugLineNum = 193;BA.debugLine="Return l";
Debug.ShouldStop(1);
if (true) return _l;
 BA.debugLineNum = 194;BA.debugLine="End Sub";
Debug.ShouldStop(2);
return null;
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}

public static void initializeProcessGlobals() {
    if (mostCurrent != null && mostCurrent.activityBA != null) {
Debug.StartDebugging(mostCurrent.activityBA, 17826, new int[] {8}, "4fae5850-05ad-4006-b16c-b82714336577");}

    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

public static void killProgram() {
    
            if (main.previousOne != null) {
				Activity a = main.previousOne.get();
				if (a != null)
					a.finish();
			}

}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 21;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 22;BA.debugLine="Dim scvList As ScrollView";
mostCurrent._scvlist = new anywheresoftware.b4a.objects.ScrollViewWrapper();
 //BA.debugLineNum = 23;BA.debugLine="Dim Table As Panel";
mostCurrent._table = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 24;BA.debugLine="Dim SelectedItems As Map";
mostCurrent._selecteditems = new anywheresoftware.b4a.objects.collections.Map();
 //BA.debugLineNum = 26;BA.debugLine="Dim NumberOfColumns,RowHeight, RowHeight_1 As Int";
_numberofcolumns = 0;
_rowheight = 0;
_rowheight_1 = 0;
 //BA.debugLineNum = 27;BA.debugLine="Type RowCol (Row As Int, Col As Int)";
;
 //BA.debugLineNum = 28;BA.debugLine="Dim LineColor  As Int";
_linecolor = 0;
 //BA.debugLineNum = 29;BA.debugLine="Dim ColumnWidth(3) As Int";
_columnwidth = new int[(int)(3)];
;
 //BA.debugLineNum = 30;BA.debugLine="Dim ColumnWidth_1(3) As Int";
_columnwidth_1 = new int[(int)(3)];
;
 //BA.debugLineNum = 31;BA.debugLine="Dim ColLineWidth, RowLineWidth As Int";
_collinewidth = 0;
_rowlinewidth = 0;
 //BA.debugLineNum = 32;BA.debugLine="Dim SelectedRow As Int";
_selectedrow = 0;
 //BA.debugLineNum = 33;BA.debugLine="Dim SelectedRowColor As Int		: SelectedRowColor = Colors.blue";
_selectedrowcolor = 0;
 //BA.debugLineNum = 33;BA.debugLine="Dim SelectedRowColor As Int		: SelectedRowColor = Colors.blue";
_selectedrowcolor = anywheresoftware.b4a.keywords.Common.Colors.Blue;
 //BA.debugLineNum = 34;BA.debugLine="Dim pnlBtnWerknemers As Panel";
mostCurrent._pnlbtnwerknemers = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 38;BA.debugLine="NumberOfColumns = 2 'will be overwritten when loading from CscvList file.";
_numberofcolumns = (int)(2);
 //BA.debugLineNum = 39;BA.debugLine="ColLineWidth = 1dip";
_collinewidth = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(1));
 //BA.debugLineNum = 40;BA.debugLine="RowLineWidth = 1dip";
_rowlinewidth = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(1));
 //BA.debugLineNum = 41;BA.debugLine="RowHeight_1 = 30dip";
_rowheight_1 = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(30));
 //BA.debugLineNum = 42;BA.debugLine="RowHeight=RowHeight_1+RowLineWidth";
_rowheight = (int)(_rowheight_1+_rowlinewidth);
 //BA.debugLineNum = 44;BA.debugLine="LineColor = Colors.Blue";
_linecolor = anywheresoftware.b4a.keywords.Common.Colors.Blue;
 //BA.debugLineNum = 47;BA.debugLine="Dim CellColor(3) As Int";
_cellcolor = new int[(int)(3)];
;
 //BA.debugLineNum = 49;BA.debugLine="CellColor(1) = Colors.white";
_cellcolor[(int)(1)] = anywheresoftware.b4a.keywords.Common.Colors.White;
 //BA.debugLineNum = 52;BA.debugLine="Dim FontColor(3) As Int";
_fontcolor = new int[(int)(3)];
;
 //BA.debugLineNum = 54;BA.debugLine="FontColor(1) = Colors.Black";
_fontcolor[(int)(1)] = anywheresoftware.b4a.keywords.Common.Colors.Black;
 //BA.debugLineNum = 57;BA.debugLine="Dim FontSize(3) As Float";
_fontsize = new float[(int)(3)];
;
 //BA.debugLineNum = 59;BA.debugLine="FontSize(1) = 12";
_fontsize[(int)(1)] = (float)(12);
 //BA.debugLineNum = 62;BA.debugLine="Dim Alignment(3) As Int";
_alignment = new int[(int)(3)];
;
 //BA.debugLineNum = 64;BA.debugLine="Alignment(1) = Gravity.CENTER";
_alignment[(int)(1)] = anywheresoftware.b4a.keywords.Common.Gravity.CENTER;
 //BA.debugLineNum = 67;BA.debugLine="End Sub";
return "";
}
public static int  _numberofrows() throws Exception{
		Debug.PushSubsStack("NumberOfRows (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 227;BA.debugLine="Sub NumberOfRows As Int";
Debug.ShouldStop(4);
 BA.debugLineNum = 228;BA.debugLine="Return Table.NumberOfViews / NumberOfColumns";
Debug.ShouldStop(8);
if (true) return (int)(mostCurrent._table.getNumberOfViews()/(double)_numberofcolumns);
 BA.debugLineNum = 229;BA.debugLine="End Sub";
Debug.ShouldStop(16);
return 0;
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 12;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 13;BA.debugLine="Dim SQL1 As SQL";
_sql1 = new anywheresoftware.b4a.sql.SQL();
 //BA.debugLineNum = 15;BA.debugLine="Dim DBFileName As String				: DBFileName = \"kleinrelmod.db\"";
_dbfilename = "";
 //BA.debugLineNum = 15;BA.debugLine="Dim DBFileName As String				: DBFileName = \"kleinrelmod.db\"";
_dbfilename = "kleinrelmod.db";
 //BA.debugLineNum = 17;BA.debugLine="Dim DBFileDir As String					: DBFileDir = File.DirRootExternal";
_dbfiledir = "";
 //BA.debugLineNum = 17;BA.debugLine="Dim DBFileDir As String					: DBFileDir = File.DirRootExternal";
_dbfiledir = anywheresoftware.b4a.keywords.Common.File.getDirRootExternal();
 //BA.debugLineNum = 19;BA.debugLine="End Sub";
return "";
}
public static String  _readsqltable() throws Exception{
		Debug.PushSubsStack("ReadSQLTable (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
int _i = 0;
anywheresoftware.b4a.sql.SQL.CursorWrapper _cursor1 = null;
String[] _row = null;
 BA.debugLineNum = 104;BA.debugLine="Sub ReadSQLTable";
Debug.ShouldStop(128);
 BA.debugLineNum = 106;BA.debugLine="Dim i As Int";
Debug.ShouldStop(512);
_i = 0;Debug.locals.put("i", _i);
 BA.debugLineNum = 107;BA.debugLine="Dim Cursor1 As Cursor";
Debug.ShouldStop(1024);
_cursor1 = new anywheresoftware.b4a.sql.SQL.CursorWrapper();Debug.locals.put("Cursor1", _cursor1);
 BA.debugLineNum = 109;BA.debugLine="Cursor1 = SQL1.ExecQuery(\"SELECT * FROM tblWerknemer\")";
Debug.ShouldStop(4096);
_cursor1.setObject((android.database.Cursor)(_sql1.ExecQuery("SELECT * FROM tblWerknemer")));
 BA.debugLineNum = 110;BA.debugLine="Cursor1.Position = 0";
Debug.ShouldStop(8192);
_cursor1.setPosition((int)(0));
 BA.debugLineNum = 112;BA.debugLine="For i = 0 To Cursor1.RowCount - 1";
Debug.ShouldStop(32768);
{
final double step67 = 1;
final double limit67 = (int)(_cursor1.getRowCount()-1);
for (_i = (int)(0); (step67 > 0 && _i <= limit67) || (step67 < 0 && _i >= limit67); _i += step67) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 113;BA.debugLine="Dim row(NumberOfColumns) As String";
Debug.ShouldStop(65536);
_row = new String[_numberofcolumns];
java.util.Arrays.fill(_row,"");Debug.locals.put("row", _row);
 BA.debugLineNum = 114;BA.debugLine="Cursor1.Position = i";
Debug.ShouldStop(131072);
_cursor1.setPosition(_i);
 BA.debugLineNum = 115;BA.debugLine="row(0)=Cursor1.GetString(\"fldWerknemerID\")";
Debug.ShouldStop(262144);
_row[(int)(0)] = _cursor1.GetString("fldWerknemerID");Debug.locals.put("row", _row);
 BA.debugLineNum = 116;BA.debugLine="row(1)=Cursor1.GetString(\"fldWerknemer\")";
Debug.ShouldStop(524288);
_row[(int)(1)] = _cursor1.GetString("fldWerknemer");Debug.locals.put("row", _row);
 BA.debugLineNum = 118;BA.debugLine="AddRow(row)";
Debug.ShouldStop(2097152);
_addrow(_row);
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 120;BA.debugLine="Cursor1.Close";
Debug.ShouldStop(8388608);
_cursor1.Close();
 BA.debugLineNum = 121;BA.debugLine="End Sub";
Debug.ShouldStop(16777216);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _selectrow(int _row) throws Exception{
		Debug.PushSubsStack("SelectRow (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
int _col = 0;
Debug.locals.put("Row", _row);
 BA.debugLineNum = 161;BA.debugLine="Sub SelectRow(Row As Int)";
Debug.ShouldStop(1);
 BA.debugLineNum = 176;BA.debugLine="If SelectedItems.ContainsKey(Row) Then";
Debug.ShouldStop(32768);
if (mostCurrent._selecteditems.ContainsKey((Object)(_row))) { 
 BA.debugLineNum = 177;BA.debugLine="For col = 0 To NumberOfColumns - 1";
Debug.ShouldStop(65536);
{
final double step106 = 1;
final double limit106 = (int)(_numberofcolumns-1);
for (_col = (int)(0); (step106 > 0 && _col <= limit106) || (step106 < 0 && _col >= limit106); _col += step106) {
Debug.locals.put("col", _col);
 BA.debugLineNum = 178;BA.debugLine="GetView(Row, col).Color = CellColor(col)";
Debug.ShouldStop(131072);
_getview(_row,_col).setColor(_cellcolor[_col]);
 }
}Debug.locals.put("col", _col);
;
 BA.debugLineNum = 180;BA.debugLine="SelectedItems.Remove(Row)";
Debug.ShouldStop(524288);
mostCurrent._selecteditems.Remove((Object)(_row));
 }else {
 BA.debugLineNum = 182;BA.debugLine="SelectedItems.Put(Row,GetView(Row, col).Text)";
Debug.ShouldStop(2097152);
mostCurrent._selecteditems.Put((Object)(_row),(Object)(_getview(_row,_col).getText()));
 BA.debugLineNum = 183;BA.debugLine="For col = 0 To NumberOfColumns - 1";
Debug.ShouldStop(4194304);
{
final double step112 = 1;
final double limit112 = (int)(_numberofcolumns-1);
for (_col = (int)(0); (step112 > 0 && _col <= limit112) || (step112 < 0 && _col >= limit112); _col += step112) {
Debug.locals.put("col", _col);
 BA.debugLineNum = 184;BA.debugLine="GetView(Row, col).Color = SelectedRowColor";
Debug.ShouldStop(8388608);
_getview(_row,_col).setColor(_selectedrowcolor);
 }
}Debug.locals.put("col", _col);
;
 };
 BA.debugLineNum = 187;BA.debugLine="End Sub";
Debug.ShouldStop(67108864);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _setcell(int _row,int _col,String _value) throws Exception{
		Debug.PushSubsStack("SetCell (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Row", _row);
Debug.locals.put("Col", _col);
Debug.locals.put("Value", _value);
 BA.debugLineNum = 231;BA.debugLine="Sub SetCell(Row As Int, Col As Int, Value As String)";
Debug.ShouldStop(64);
 BA.debugLineNum = 233;BA.debugLine="GetView(Row, Col).Text = Value";
Debug.ShouldStop(256);
_getview(_row,_col).setText((Object)(_value));
 BA.debugLineNum = 234;BA.debugLine="End Sub";
Debug.ShouldStop(512);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _terugvisible_click() throws Exception{
		Debug.PushSubsStack("TerugVisible_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 250;BA.debugLine="Sub TerugVisible_Click";
Debug.ShouldStop(33554432);
 BA.debugLineNum = 251;BA.debugLine="Table.Visible = True";
Debug.ShouldStop(67108864);
mostCurrent._table.setVisible(anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 252;BA.debugLine="pnlBtnWerknemers.Visible = True";
Debug.ShouldStop(134217728);
mostCurrent._pnlbtnwerknemers.setVisible(anywheresoftware.b4a.keywords.Common.True);
 BA.debugLineNum = 253;BA.debugLine="End Sub";
Debug.ShouldStop(268435456);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
  public Object[] GetGlobals() {
		return new Object[] {"Activity",_activity,"SQL1",_sql1,"DBFileName",_dbfilename,"DBFileDir",_dbfiledir,"scvList",_scvlist,"Table",_table,"SelectedItems",_selecteditems,"NumberOfColumns",_numberofcolumns,"RowHeight",_rowheight,"RowHeight_1",_rowheight_1,"LineColor",_linecolor,"ColumnWidth",_columnwidth,"ColumnWidth_1",_columnwidth_1,"ColLineWidth",_collinewidth,"RowLineWidth",_rowlinewidth,"SelectedRow",_selectedrow,"SelectedRowColor",_selectedrowcolor,"pnlBtnWerknemers",_pnlbtnwerknemers,"CellColor",_cellcolor,"FontColor",_fontcolor,"FontSize",_fontsize,"Alignment",_alignment};
}
}
